/*
	Copyright (c) 2004 Pablo Bleyer Kocik.

	Redistribution and use in source and binary forms, with or without
	modification, are permitted provided that the following conditions are met:

	1. Redistributions of source code must retain the above copyright notice, this
	list of conditions and the following disclaimer.

	2. Redistributions in binary form must reproduce the above copyright notice,
	this list of conditions and the following disclaimer in the documentation
	and/or other materials provided with the distribution.

	3. The name of the author may not be used to endorse or promote products
	derived from this software without specific prior written permission.

	THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
	WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
	MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
	EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
	SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
	PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
	BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
	IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
	POSSIBILITY OF SUCH DAMAGE.
*/

import java.util.Vector;

public class Formatter1 {

	String formatHex(int n, int p) {
		String h = Integer.toHexString(n);
		int hl = p-h.length();
		for (int m=0; m<hl; ++m) h = "0" + h;
		return h;
	}

	String formatVerilog(String name, int[] prg) {
		StringBuffer b = new StringBuffer();
		b.append(
"module " + name + "(address, instruction, clk);\n"
		);
		b.append(
"input [7:0] address;\n" +
"output [15:0] instruction;\n" +
"input clk;\n" +
"RAMB4_S16 ram_256_x_16(\n" +
"	.DI  (16'b0),\n" +
"	.EN (1'b1),\n" +
"	.WE (1'b0),\n" +
"	.RST (1'b0),\n" +
"	.CLK (clk),\n" +
"	.ADDR(address),\n" +
"	.DO (instruction)\n" +
");\n" +
"// synthesis translate_off\n"
		);

		String[] hn = new String[16];

		for (int i=0; i<16; ++i) {
			String h = "";
			for (int j=0; j<16; ++j) h = formatHex(prg[j+i*16],4) + h;
			hn[i] = h.toUpperCase();
		}

		for (int i=0; i<16; ++i)
			b.append(
"defparam ram_256_x_16.INIT_" +
	formatHex(i, 2).toUpperCase() + " = 256'h" + hn[i] + ";\n"
			);

		b.append(
"// synthesis translate_on\n"
		);

		for (int i=0; i<16; ++i)
			b.append(
"// synthesis attribute INIT_" +
	formatHex(i, 2).toUpperCase() + " of ram_256_x_16 is \"" +
	hn[i] + "\"\n"
		);

		b.append(
"endmodule\n"
		);

		return b.toString();
	}

}
